// Copyright 1996, 2008 by Jon Dart. All Rights Reserved.
//
#include "epdrec.h"
#include "strpair.h"
#include <string.h>
#include <iterator>

EPDRecord::EPDRecord()
{
}

EPDRecord::~EPDRecord()
{
}

bool EPDRecord::hasVal(const char * key) const
{
   list<StringPair>::const_iterator it = cmds.begin();
   while (it != cmds.end())
   {
      if ((*it).tag == key)
      {
         return true;
      }
      it++;
   }
   return false;
}

bool EPDRecord::getVal(const char * key, string &val) const
{
   list<StringPair>::const_iterator it = cmds.begin();
   while (it != cmds.end())
   {
      if ((*it).tag == key)
      {
         val = (*it).val;
         return true;
      }
   }
   return false;
}

bool EPDRecord::getData(int i,string &key,string &val) const
{
   list<StringPair>::const_iterator it = cmds.begin();
   int index = 0;
   while (it != cmds.end())
   {
      if (index == i)
      {
         val = (*it).val;
         key = (*it).tag;
         return true;
      }
      ++index;
      it++;
   }
   return false;
}

void EPDRecord::add(const char * key, const char * value)
{
   cmds.push_back(StringPair(key,value));
}

void EPDRecord::clear() {
   err = "";
   cmds.clear();
}

